
package eu.dnetlib.dhp.rdfconverter.bioschema;

import java.io.InputStream;
import java.util.ArrayList;

import org.apache.commons.io.IOUtils;
import org.junit.jupiter.api.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import eu.dnetlib.dhp.rdfconverter.utils.CompressorUtil;
import eu.dnetlib.dhp.rdfconverter.utils.RDFConverter;

public class ConverterTest {

	static Logger logger = LoggerFactory.getLogger(ConverterTest.class);

	@Test
	public void disprotToDataciteTest() throws Exception {
		InputStream is = ConverterTest.class.getResourceAsStream("/eu/dnetlib/dhp/rdfconverter/bioschema/disprot.nq");
		String nq = IOUtils.toString(is);
		RDFConverter converter = new RDFConverter();
		ArrayList<String> results = converter.nQuadsFile2DataciteJson(nq, "Protein");
		results.stream().forEach(r -> {
			logger.info("JSON DATACITE >> " + r);
		});
	}

	@Test
	public void pedCitationTest() throws Exception {
		InputStream is = ConverterTest.class.getResourceAsStream("/eu/dnetlib/dhp/rdfconverter/bioschema/ped.nq");
		String nq = IOUtils.toString(is);
		RDFConverter converter = new RDFConverter();
		ArrayList<String> results = converter.nQuadsFile2DataciteJson(nq, "Protein");
		results.stream().forEach(r -> {
			logger.info("JSON DATACITE >> " + r);
		});
	}

	@Test
	public void mobidbToDataciteTest() throws Exception {
		InputStream is = ConverterTest.class.getResourceAsStream("/eu/dnetlib/dhp/rdfconverter/bioschema/mobidb.nq");
		String nq = IOUtils.toString(is);
		RDFConverter converter = new RDFConverter();
		ArrayList<String> results = converter.nQuadsFile2DataciteJson(nq, "Protein");
		results.stream().forEach(r -> {
			logger.info("JSON DATACITE >> " + r);
		});
	}

	@Test
	public void decompressTest() throws Exception {
		InputStream is = ConverterTest.class
			.getResourceAsStream("/eu/dnetlib/dhp/rdfconverter/bioschema/base64_gzipped_nquads.txt");
		String base64_gzipped_nquads = IOUtils.toString(is);
		String nq = CompressorUtil.decompressValue(base64_gzipped_nquads);
		RDFConverter converter = new RDFConverter();
		ArrayList<String> results = converter.nQuadsFile2DataciteJson(nq, "Protein");
		results.stream().forEach(r -> {
			logger.info("JSON DATACITE >> " + r);
		});
	}
}
